<?php
require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');

/**
 * Class FreinetPortalAdminSuchkonfigurationTable
 * Die Tabelle unter dem Menüpunkt "Suchkonfiguration verwalten"
 */
class FreinetPortalAdminSuchkonfigurationTable extends WP_List_Table
{
    function __construct()
    {
        parent::__construct(array(
            'singular'=>'Suchkonfiguration',
            'plural'=>'Suchkonfigurationen',
            'ajax'=>false
        ));

    }


    function column_default($item, $column_name)
    {
        switch($column_name)
        {
            case 'ID':
                return $item['ID'];
            case 'name':
                return $item['name'];
            case 'createdBy':
                return $item['createdBy'];
            case 'freinet_portal_action':
                $itemId=$item['ID'];
                return sprintf(
                    '<form method="post" action="%s">
                                <input type="hidden" name="freinet_portal_suchkonfiguration_id" value="%s"/>
                                <input type="hidden" name="action" value="freinet_portal_suchkonfiguration_entfernen"/>
                                <a href="%s" class="button-primary">Bearbeiten</a> 
                                <button type="submit" class="button-primary" onclick="return confirm(\'Soll die Suchkonfiguration <%s> wirklich entfernt werden?\');">Entfernen</button>
                                %s
                            </form>', esc_html(admin_url('admin-post.php')), $item['ID'], esc_html(add_query_arg(array("freinet_portal_suchkonfiguration"=>$item["ID"], "freinet_portal_suchkonfiguration_action"=>"anpassen"))), $item['name'], wp_nonce_field('freinet_portal_suchkonfiguration_entfernen')
                );
            default:
                return print_r($item, true);
        }
    }


    function column_IDabc($item)
    {
        $actions=array(
            'edit'=>sprintf('<a href="?page=%s&action=%s&suchkonfiguration=%s">Bearbeiten</a>', $_REQUEST['page'], 'edit', $item['ID']),
            'delete'=>sprintf('<form><input type="hidden" value="' . $item['ID'] . '"> <button type="submit" href="?page=%s&action=%s&suchkonfiguration=%s" onclick="return confirm(\'Soll die Suchkonfiguration entfernt werden?\');">Entfernen</button></form>', $_REQUEST['page'], 'delete', $item['ID']),
        );
        return sprintf('ID: %1$s%2$s',
            $item['ID'],
            $this->row_actions($actions)
        );
    }


    function get_columns()
    {
        $columns=array(
            'ID'=>'SuchkonfigurationsID',
            'name'=>'Name',
            'createdBy'=>'Angelegt durch',
            'freinet_portal_action'=>'Aktion'
        );
        return $columns;
    }


    function get_sortable_columns()
    {
        $sortable_columns=array(
            'ID'=>array('ID', false),
            'name'=>array('name', false)
        );
        return $sortable_columns;
    }

    function prepare_items()
    {
        $per_page=100;
        $columns=$this->get_columns();
        $hidden=array();
        $sortable=$this->get_sortable_columns();
        $this->_column_headers=array($columns, $hidden, $sortable);
        $data=$this->fetchInstanzListe();
        function usort_reorder($a, $b)
        {
            $orderby=(!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'ID';
            $order=(!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'asc';
            $result=strcmp($a[$orderby], $b[$orderby]);
            return ($order==='asc') ? $result : -$result;
        }

        usort($data, 'usort_reorder');
        $current_page=$this->get_pagenum();
        $total_items=count($data);
        $data=array_slice($data, (($current_page - 1) * $per_page), $per_page);
        $this->items=$data;
        $this->set_pagination_args(array(
            'total_items'=>$total_items,
            'per_page'=>$per_page,
            'total_pages'=>ceil($total_items / $per_page)
        ));
    }

    private function fetchInstanzListe()
    {
        $instanzListe=array();
        $instanzListeConfigValue=get_option('freinet_portal_instanz_liste');
        if(empty($instanzListeConfigValue))
        {
            return $instanzListe;
        }
        $instanzListenIds=explode(',', $instanzListeConfigValue);
        echo count($instanzListenIds);
        array_walk($instanzListenIds, function ($instanzId) use (&$instanzListe) {
            $item=array('ID'=>$instanzId,
                'name'=>get_option(FreinetPortalSettings::freinet_portal_suchkonfiguration_anzeige_name($instanzId)),
                'createdBy'=>get_option(FreinetPortalSettings::freinet_portal_angelegt_durch($instanzId), esc_html('Keine Angabe vorhanden')));
            array_push($instanzListe, $item);
        });
        return $instanzListe;
    }
}