<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;
require_once 'ImageTagRenderer.php';
/**
 * Class FreinetPortalAngebotDetail
 * Verarbeitet die XML Daten vom OfferServiceEndpoint
 * @lastmodified // 2020-10-24 added anforderungen, agentur->avatar
 */
class FreinetPortalAngebotDetail
{
	private $angebotXmlData;

	public function __construct($angebotXmlData)
	{
		// echo '<br>FreinetPortalAngebotDetail::__construct:'.freinet_portal_print_a(freinet_portal_object2array($angebotXmlData),1); // unkommentieren zum testen und entwickeln

		$this->angebotId=$_REQUEST['freinet_portal_wp_angebot_nummer']; // @Todo Es gibt im xml response garkeine AngebotId
		$this->angebotName=$angebotXmlData->angebot_details->angebotsname;
		$this->angebotKontaktierbar=$angebotXmlData->angebot_details->kontaktierbar;
		$this->angebotAvatar=$angebotXmlData->angebot_details->avatar;
		$this->angebotAvatarInfo=$angebotXmlData->angebot_details->avatarinfo;
		$this->angebotAnzahlGesuche=$angebotXmlData->angebot_details->anzahl_gesuche;
		$this->angebotStatus=$angebotXmlData->angebot_details->such_status;
		$this->angebotErstellt=$angebotXmlData->angebot_details->erstellt;
		$this->angebotBearbeitet=$angebotXmlData->angebot_details->bearbeitet;
		$this->angebotAnzahlAktuellerVermittlungen=$angebotXmlData->angebot_details->anzahl_aktueller_vermittlungen;
		$this->angebotAnmeldungErlaubt=$angebotXmlData->angebot_details->anmeldung_erlaubt;
		$this->angebotBeschreibung=$angebotXmlData->angebot_details->beschreibung;
		$this->angebotBarrierefreiheit=$angebotXmlData->angebot_details->behindertengerecht;
		$this->angebotSprechzeiten=$angebotXmlData->angebot_details->sprechzeiten;
		$this->angebotZeitlicherRahmen=$angebotXmlData->angebot_details->zeitlicherrahmen;
		$this->angebotLeistungen=$angebotXmlData->angebot_details->termine;
		$this->angebotBefristet=$angebotXmlData->angebot_details->befristet;
		$this->angebotLeistungen=$angebotXmlData->angebot_details->leistungen;
		$this->angebotAnforderungen=$angebotXmlData->angebot_details->anforderungen;
		$this->angebotHandlungsfelder=$angebotXmlData->angebot_details->handlungsfelder;
		$this->angebotArbeitsweise=$angebotXmlData->angebot_details->arbeitsweisen;
		$this->angebotGlobalbereiche=$angebotXmlData->angebot_details->globalbereiche;
		$this->angebotSprachen=$angebotXmlData->angebot_details->sprachen;
		$this->angebotGeoWidth=$angebotXmlData->angebot_details->geo_x;
		$this->angebotGeoLength=$angebotXmlData->angebot_details->geo_y;
		// Angebot Anschrift
		$this->angebotStrasse=$angebotXmlData->angebot_details->strasse;
		$this->angebotPLZ=$angebotXmlData->angebot_details->plz;
		$this->angebotOrt=$angebotXmlData->angebot_details->ort;
		// Angebot Kontaktdaten
		$this->angebotVorname=$angebotXmlData->angebot_details->vorname;
		$this->angebotNachname=$angebotXmlData->angebot_details->nachname;
		$this->angebotTelefon=$angebotXmlData->angebot_details->telefon;
		$this->angebotFax=$angebotXmlData->angebot_details->fax;
		$this->angebotMail=$angebotXmlData->angebot_details->email;
		$this->angebotHomepage=$angebotXmlData->angebot_details->homepage;

		// Einrichtung
		$this->einrichtungId=freinet_portal_xml_attribute($angebotXmlData->einrichtung_details, 'id');
		$this->einrichtungName=$angebotXmlData->einrichtung_details->name;
		$this->einrichtungBeschreibung=$angebotXmlData->einrichtung_details->beschreibung;
		$this->einrichtungSprechzeiten=$angebotXmlData->einrichtung_details->sprechzeiten;
		// Einrichtung Anschrift
		$this->einrichtungStrasse=$angebotXmlData->einrichtung_details->strasse;
		$this->einrichtungPLZ=$angebotXmlData->einrichtung_details->plz;
		$this->einrichtungOrt=$angebotXmlData->einrichtung_details->ort;
		$this->einrichtungGeoWidth=$angebotXmlData->einrichtung_details->geo_x;
		$this->einrichtungGeoLength=$angebotXmlData->einrichtung_details->geo_y;
		// einrichtungId Kontaktdaten
		$this->einrichtungVorname=$angebotXmlData->einrichtung_details->vorname;
		$this->einrichtungNachname=$angebotXmlData->einrichtung_details->nachname;
		$this->einrichtungTelefon=$angebotXmlData->einrichtung_details->telefon;
		$this->einrichtungFax=$angebotXmlData->einrichtung_details->fax;
		$this->einrichtungMail=$angebotXmlData->einrichtung_details->email;
		$this->einrichtungHomepage=$angebotXmlData->einrichtung_details->homepage;
		$this->einrichtungAvatar=$angebotXmlData->einrichtung_details->avatar; // 2020-10-26
		$this->einrichtungAvatarInfo=$angebotXmlData->einrichtung_details->avatarinfo; // 2020-10-26
		$this->einrichtungLogo=$angebotXmlData->einrichtung_details->logo; // 2020-10-26
		$this->einrichtungLogoInfo=$angebotXmlData->einrichtung_details->logoinfo; // 2020-10-26

		// Traeger
		// Todo

		// Agentur ( agentur_details @attributes id )
		$this->agenturId=freinet_portal_xml_attribute($angebotXmlData->agentur_details, 'id');
		$this->agenturName=$angebotXmlData->agentur_details->name;
		$this->agenturBeschreibung=$angebotXmlData->agentur_details->beschreibung;
		$this->agenturSprechzeiten=$angebotXmlData->agentur_details->sprechzeiten;
		// Agentur Anschrift
		$this->agenturStrasse=$angebotXmlData->agentur_details->strasse;
		$this->agenturPLZ=$angebotXmlData->agentur_details->plz;
		$this->agenturOrt=$angebotXmlData->agentur_details->ort;
		$this->agenturGeoWidth=$angebotXmlData->agentur_details->geo_x;
		$this->agenturGeoLength=$angebotXmlData->agentur_details->geo_y;
		// Agentur Kontaktdaten
		$this->agenturVorname=$angebotXmlData->agentur_details->vorname;
		$this->agenturNachname=$angebotXmlData->agentur_details->nachname;
		$this->agenturTelefon=$angebotXmlData->agentur_details->telefon;
		$this->agenturFax=$angebotXmlData->agentur_details->fax;
		$this->agenturMail=$angebotXmlData->agentur_details->email;
		$this->agenturHomepage=$angebotXmlData->agentur_details->homepage;
		$this->agenturAvatar=$angebotXmlData->agentur_details->avatar; // 2020-10-25
		$this->agenturLogo=$angebotXmlData->agentur_details->logo; // 2020-10-25

		$this->AlleParamter=$angebotXmlData;

	}

	public function getDetailAngebotName()
	{
		return $this->angebotName;
	}

	public function getDetailAngebotsId()
	{
		return $this->angebotId;
	}

	public function getDetailAngebotsKontaktierbarbkeit()
	{
		return $this->angebotKontaktierbar;
	}

	public function getDetailEinrichtungname()
	{
		return $this->einrichtungName;
	}

	public function getDetailAgenturname()
	{
		return $this->agenturName;
	}

	public function getDetailAngebotBeschreibungAsHTML()
	{
		return '<div itemprop="description">'.$this->angebotBeschreibung.'</div>';
	}

	public function getDetailEinrichtungBeschreibungAsHTML()
	{
		return '<div itemprop="description">'.$this->einrichtungBeschreibung.'</div>';
	}

	public function getDetailAgenturBeschreibungAsHTML()
	{
		return '<div itemprop="description">'.$this->agenturBeschreibung.'</div>';
	}

	public function getDetailBarrierefreiheit()
	{
		return $this->angebotBarrierefreiheit;
	}

	/**
	 * Leistungen kommen als Array
	 * @return string
	 */
	public function getDetailLeistungenAsHTML()
	{
		if(!is_object($this->angebotLeistungen->element)) return '';

		$arr=(array)$this->angebotLeistungen->element;

		if(empty($arr)) return '';

		// Ausgabe als html Liste
		return '<span itmprop="jobBenefits">'.freinet_portal_array2ul($arr, 'ul', 0, 'DetailLeistungenListe').'</span>';

		// Ausgabe als "CSV"
		//return implode(', ',$new_arr[element]);

	}

	/**
	 * Anforderungen kommen als Array
	 * @since // 2020-10-25
	 * @return string
	 */
	public function getDetailAnforderungenAsHTML()
	{
		if(!is_object($this->angebotAnforderungen->element)) return '';

		$arr=(array)$this->angebotAnforderungen->element;

		if(empty($arr)) return '';

		// Ausgabe als html Liste
		return '<span itmprop="skills">'.freinet_portal_array2ul($arr, 'ul', 0, 'DetailAnforderungenListe').'</span>';

		// Ausgabe als "CSV"
		//return implode(', ',$new_arr[element]);

	}

	public function getDetailAnzahlGesuche()
	{
		if($this->angebotAnzahlGesuche<0) return '';
		return $this->angebotAnzahlGesuche;
	}

	public function getDetailAnzahlAktuellerVermittlungenAsHTML()
	{
		if($this->angebotAnzahlAktuellerVermittlungen<0) return '';
		return $this->angebotAnzahlAktuellerVermittlungen;
	}

	public function getDetailAngebotErstelltAsHTML()
	{
		if($this->angebotErstellt<0) return '';
		// Lesbare Variante
		$out=date('d.m.Y', (string)$this->angebotErstellt);
		// Schema Variante
		$out.='<span style="display:none;" itemprop="datePosted">'.date('Y-m-d', (string)$this->angebotErstellt).'</span>';
		return $out;
	}

	public function getDetailAngebotBearbeitetAsHTML()
	{
		if($this->angebotBearbeitet<0) return '';
		return date('d.m.Y', (string)$this->angebotBearbeitet);
	}

	public function getDetailAnmeldungErlaubtAsHTML()
	{
		return '<a target="_blank" href="//freinet-online.de/forum/register_extern.php?assign_to_agid='.$this->agenturId.'&advice_to_offer='.$this->angebotId.'&assign_to_group=6&simple_form=1">Anmeldung</a>';
	}

	/**
	 * Freie Stellen sind die Differenz von der Anzal der Gesuche und der Anzahl der aktuellen Vermittlungen
	 * @return string
	 */
	public function getDetailFreieStellen()
	{
		$FreieStellen=($this->angebotAnzahlGesuche-$this->angebotAnzahlAktuellerVermittlungen);

		if($FreieStellen<0) return '';
		return $FreieStellen;
	}

	/**
	 * Freie Stellen sind die Differenz von der Anzal der Gesuche und der Anzahl der aktuellen Vermittlungen
	 * @return string
	 */
	public function getDetailAngebotStatus()
	{
		return $this->angebotStatus;
	}

	/**
	 * Sprachen kommen als Array
	 * @since // 2018-10-26
	 * @return string
	 */
	public function getDetailSprachenAsHtml()
	{
		if(!is_object($this->angebotSprachen->element)) return '';

		$arr=(array)$this->angebotSprachen->element;

		if(empty($arr)) return '';

		// Ausgabe als html Liste
		return freinet_portal_array2ul($arr, 'ul', 0, 'DetailSprachenListe');

		// Ausgabe als "CSV"
		//return implode(', ',$new_arr[element]);
	}

	/**
	 * Handlungsfelder kommen als Array
	 * @return string
	 */
	public function getDetailHandlungsfelderAsHtml()
	{
		if(!is_object($this->angebotHandlungsfelder->element)) return '';

		$arr=(array)$this->angebotHandlungsfelder->element;

		if(empty($arr)) return '';

		// Ausgabe als html Liste
		return freinet_portal_array2ul($arr, 'ul', 0, 'DetailHandlungsfelderListe');

		// Ausgabe als "CSV"
		//return implode(', ',$new_arr[element]);

	}

	/**
	 * Arbeitsweise kommen als Array
	 * @return string
	 */
	public function getDetailArbeitsweiseAsHtml()
	{
		if(!is_object($this->angebotArbeitsweise->element)) return '';

		$arr=(array)$this->angebotArbeitsweise->element;

		if(empty($arr)) return '';

		// Ausgabe als html Liste
		return freinet_portal_array2ul($arr, 'ul', 0, 'DetailArbeitsweiseListe');

		// Ausgabe als "CSV"
		//return implode(', ',$new_arr[element]);

	}


	/**
	 * Globalbereiche kommen als Array
	 * @return string
	 */
	public function getDetailGlobalbereicheAsHtml()
	{
		if(!is_object($this->angebotGlobalbereiche->element)) return '';

		$arr=(array)$this->angebotGlobalbereiche->element;

		if(empty($arr)) return '';

		// Ausgabe als html Liste
		return freinet_portal_array2ul($arr, 'ul', 0, 'DetailGlobalbereicheListe');

		// Ausgabe als "CSV"
		//return implode(', ',$new_arr[element]);

	}

	public function getDetailAngebotAvatarAsHTML()
	{
		/*
		 * @ToDo Die Groesse des Avatars sollte im Adminarea waehlbar sein.
		 * Die Avatare liegen unter der URL //freinet-online.de/content/files/ds_avatar/ in verschiedenen Groessen vor
		 * avatar_h20px.jpg|.png
		 * avatar_w100px.jpg|.png
		 * avatar_w150px.jpg|.png
		 * avatar_w250px.jpg|.png
		 * avatar.jpg|.png // Achtung - Original (Groesse beachten!)
		 */
		if($this->angebotAvatar!='')
		{
			return FreinetPortalImageTagRenderer::fromUrl('//freinet-online.de/content/files/ds_avatar/' . $this->angebotAvatar, 'image', $this->angebotAvatarInfo);
		}
		elseif(get_option('freinet_portal_show_avatar_dummy')!='')
		{
		    $image = new FreinetPortalImageTagRenderer(get_option('freinet_portal_show_avatar_dummy'));
			return $image->render();
		}
		else
		{
			return '';
		}
	}

	/**
	 * @return string
	 * @since // 2020-10-25
	 */
	public function getDetailAgenturAvatarAsHTML()
	{
		/*
		 * @ToDo Die Groesse des Avatars sollte im Adminarea waehlbar sein.
		 * Die Avatare liegen unter der URL //freinet-online.de/content/files/ds_avatar/ in verschiedenen Groessen vor
		 * avatar_h20px.jpg|.png
		 * avatar_w100px.jpg|.png
		 * avatar_w150px.jpg|.png
		 * avatar_w250px.jpg|.png
		 * avatar.jpg|.png // Achtung - Original (Groesse beachten!)
		 */
		if($this->agenturAvatar!='')
		{
			return FreinetPortalImageTagRenderer::fromUrl('//freinet-online.de/content/files/ds_avatar/' . $this->agenturAvatar, 'image', $this->agenturAvatarInfo);
		}
		elseif(get_option('freinet_portal_show_avatar_dummy')!='')
		{
			$image = new FreinetPortalImageTagRenderer(get_option('freinet_portal_show_avatar_dummy'));
			return $image->render();
		}
		else
		{
			return '';
		}
	}

	/**
	 * @return string
	 * @since // 2020-10-25
	 */
	public function getDetailEinrichtungAvatarAsHTML()
	{
		/*
		 * @ToDo Die Groesse des Avatars sollte im Adminarea waehlbar sein.
		 * Die Avatare liegen unter der URL //freinet-online.de/content/files/ds_avatar/ in verschiedenen Groessen vor
		 * avatar_h20px.jpg|.png
		 * avatar_w100px.jpg|.png
		 * avatar_w150px.jpg|.png
		 * avatar_w250px.jpg|.png
		 * avatar.jpg|.png // Achtung - Original (Groesse beachten!)
		 */
		if($this->einrichtungAvatar!='')
		{
			return FreinetPortalImageTagRenderer::fromUrl('//freinet-online.de/content/files/ds_avatar/' . $this->einrichtungAvatar, 'image', $this->einrichtungAvatarInfo);
		}
		elseif(get_option('freinet_portal_show_avatar_dummy')!='')
		{
			$image = new FreinetPortalImageTagRenderer(get_option('freinet_portal_show_avatar_dummy'));
			return $image->render();
		}
		else
		{
			return '';
		}
	}
	
	public function getDetailEinrichtungLogoAsHTML()
	{
		/*
		 * @ToDo Die Groesse des Logos sollte im Adminarea waehlbar sein.
		 * Die Avatare liegen unter der URL //freinet-online.de/content/files/ds_avatar/ in verschiedenen Groessen vor
		 * logo_h20px.jpg|.png
		 * logo_w100px.jpg|.png
		 * logo_w150px.jpg|.png
		 * logo_w250px.jpg|.png
		 * logo.jpg|.png // Achtung - Original (Groesse beachten!)
		 */

		if($this->einrichtungLogo!='')
		{
			return FreinetPortalImageTagRenderer::fromUrl('//freinet-online.de/content/files/ds_logo/' . $this->einrichtungLogo, 'image', $this->einrichtungLogoInfo);
		}
		elseif(get_option('freinet_portal_show_avatar_dummy')!='')
		{
		    $image = new FreinetPortalImageTagRenderer(get_option('freinet_portal_show_avatar_dummy'));
			return $image->render();
		}
		else
		{
			return '';
		}
	}

	/**
	 * @return string
	 * @since // 2020-10-25
	 */
	public function getDetailAgenturLogoAsHTML()
	{
		/*
		 * @ToDo Die Groesse des Logos sollte im Adminarea waehlbar sein.
		 * Die Avatare liegen unter der URL //freinet-online.de/content/files/ds_avatar/ in verschiedenen Groessen vor
		 * logo_h20px.jpg|.png
		 * logo_w100px.jpg|.png
		 * logo_w150px.jpg|.png
		 * logo_w250px.jpg|.png
		 * logo.jpg|.png // Achtung - Original (Groesse beachten!)
		 */
		if($this->agenturLogo!='')
		{
			return FreinetPortalImageTagRenderer::fromUrl('//freinet-online.de/content/files/ds_logo/' . $this->agenturLogo, 'image', $this->agenturLogoInfo);
		}
		elseif(get_option('freinet_portal_show_logo_dummy')!='')
		{	// Diese Einstellung gibt derzeit noch nicht
			$image = new FreinetPortalImageTagRenderer(get_option('freinet_portal_show_logo_dummy'));
			return $image->render();
		}
		else
		{
			return '';
		}
	}

	public function getDetailAngebotSprechzeitenAsHTML()
	{
		if($this->angebotSprechzeiten=='') return '';
		return '<span itemprop="hoursAvailable">'.nl2br($this->angebotSprechzeiten).'</span>';
	}

	public function getDetailEinrichtungSprechzeitenAsHTML()
	{
		if($this->einrichtungSprechzeiten=='') return '';
		return '<span itemprop="hoursAvailable">'.nl2br($this->einrichtungSprechzeiten).'</span>';
	}

	public function getDetailAgenturSprechzeitenAsHTML()
	{
		if($this->agenturSprechzeiten=='') return '';
		return '<span itemprop="hoursAvailable">'.nl2br($this->agenturSprechzeiten).'</span>';
	}

	public function getDetailZeitlicherRahmen()
	{
		if($this->angebotZeitlicherRahmen=='') return '';
		return '<span itemprop="workHours">'.nl2br($this->angebotZeitlicherRahmen).'</span>';
	}

	public function getDetailBefristet()
	{
		if($this->angebotBefristet=='') return '';
		return '<span itemprop="workHours">'.nl2br($this->angebotBefristet).'</span>';
	}

	public function getDetailAngebotKontaktdatenAsHTML()
	{
		$tmp[]=array();
		if($this->angebotVorname!='') $tmp['name']='<span property="name">'.$this->angebotVorname.' '.$this->angebotNachname.'</span>';
		if($this->angebotTelefon!='') $tmp[]='<i class="fas fa-fw fa-phone" aria-hidden="true"></i> <span property="telephone">'.$this->angebotTelefon.'</span>';
		if($this->angebotFax!='') $tmp[]=' <i class="fas fa-fw fa-fax" aria-hidden="true"></i> <span property="faxNumber">'.$this->angebotFax.'</span>';
		if($this->angebotMail!='') $tmp[]=' <i class="fas fa-fw fa-envelope" aria-hidden="true"></i> <span property="email">'.$this->angebotMail.'</span>';
		if($this->angebotHomepage!='') $tmp[]=' <i class="fas fa-fw fa-home" aria-hidden="true"></i> <span property="url">'.$this->angebotHomepage.'</span>';

		return '<span vocab="http://schema.org/" typeof="Person">'.implode("<br>\n", array_filter($tmp)).'</span>';
	}

	public function getDetailEinrichtungKontaktdatenAsHTML()
	{
		$tmp[]=array();
		if($this->einrichtungVorname!='') $tmp['name']='<span property="name">'.$this->einrichtungVorname.' '.$this->einrichtungNachname.'</span>';
		if($this->einrichtungTelefon!='') $tmp[]='<i class="fas fa-fw fa-phone" aria-hidden="true"></i> <span property="telephone">'.$this->einrichtungTelefon.'</span>';
		if($this->einrichtungFax!='') $tmp[]=' <i class="fas fa-fw fa-fax" aria-hidden="true"></i> <span property="faxNumber">'.$this->einrichtungFax.'</span>';
		if($this->einrichtungMail!='') $tmp[]=' <i class="fas fa-fw fa-envelope" aria-hidden="true"></i> <span property="email">'.$this->einrichtungMail.'</span>';
		if($this->einrichtungHomepage!='') $tmp[]=' <i class="fas fa-fw fa-home" aria-hidden="true"></i> <span property="url">'.$this->einrichtungHomepage.'</span>';

		return '<span vocab="http://schema.org/" typeof="Person">'.implode("<br>\n", array_filter($tmp)).'</span>';
	}

	public function getDetailAgenturKontaktdatenAsHTML()
	{
		$tmp[]=array();
		if($this->agenturVorname!='') $tmp['name']='<span property="name">'.$this->agenturVorname.' '.$this->agenturNachname.'</span>';
		if($this->agenturTelefon!='') $tmp[]='<i class="fas fa-fw fa-phone" aria-hidden="true"></i> <span property="telephone">'.$this->agenturTelefon.'</span>';
		if($this->agenturFax!='') $tmp[]=' <i class="fas fa-fw fa-fax" aria-hidden="true"></i> <span property="faxNumber">'.$this->agenturFax.'</span>';
		if($this->agenturMail!='') $tmp[]=' <i class="fas fa-fw fa-envelope" aria-hidden="true"></i> <span property="email">'.$this->agenturMail.'</span>';
		if($this->agenturHomepage!='') $tmp[]=' <i class="fas fa-fw fa-home" aria-hidden="true"></i> <span property="url">'.$this->agenturHomepage.'</span>';

		return '<span vocab="http://schema.org/" typeof="Person">'.implode("<br>\n", array_filter($tmp)).'</span>';
	}

	/**
	 * Hat das Angebot eine Anschrift?
	 * @return int
	 */
	public function AngebotHasAddress()
	{
		if(empty(array_filter(array($this->angebotStrasse, $this->angebotPLZ, $this->angebotOrt))))
		{
			return 0;
		}
		else
		{
			return 1;
		}
	}

	/**
	 * Hat die Einrichtung eine Anschrift?
	 * @return int
	 */
	public function EinrichtungHasAddress()
	{
		if(empty(array_filter(array($this->einrichtungStrasse, $this->einrichtungPLZ, $this->einrichtungOrt))))
		{
			return 0;
		}
		else
		{
			return 1;
		}
	}

	/**
	 * Hat die Einrichtung eine Anschrift?
	 * @return int
	 */
	public function AgenturHasAddress()
	{
		if(empty(array_filter(array($this->agenturStrasse, $this->agenturPLZ, $this->agenturOrt))))
		{
			return 0;
		}
		else
		{
			return 1;
		}
	}

	/*
freinet_portal_Template('DetailZweiSpaltig', $titel='Kontaktdaten', $content=$freinetAngebot->getEinrichtungKontaktdatenAsHTML(), $id='DetailKontaktdaten', $class='', $hide_if_empty=1);
freinet_portal_Template('DetailZweiSpaltig', $titel='Anschrift', $content=$freinetAngebot->getEinrichtungAnschriftAsHTML(), $id='DetailAnschrift', $class='', $hide_if_empty=1);
freinet_portal_Template('DetailZweiSpaltig', $titel='Sprech- / &Ouml;ffnungszeiten', $content=$freinetAngebot->getEinrichtungSprechzeitenAsHTML(), $id='DetailSprechzeiten', $class='', $hide_if_empty=1);
echo $freinetAngebot->getEinrichtungMapAsHTML();
	*/

	public function getDetailAngebotAnschriftAsHTML()
	{

		if(empty(array_filter(array((string)$this->angebotStrasse, (string)$this->angebotPLZ, (string)$this->angebotOrt)))) return '';

		$tmp[]=array();
		if($this->angebotStrasse!='') $tmp['strasse']='<span property="streetAddress">'.$this->angebotStrasse.'</span>';
		if($this->angebotPLZ!='') $tmp['plz_ort']='<span itemprop="postalCode">'.$this->angebotPLZ.'</span>';
		if($this->angebotOrt!='') $tmp['plz_ort'].=' <span itemprop="addressLocality">'.$this->angebotOrt.'</span>';

		if(empty($tmp)) return '';

		return '<span itemprop="jobLocation" itemscope itemtype="http://schema.org/Place"><span itemprop="address" itemscope itemtype="http://schema.org/PostalAddress">'.implode("<br>\n", array_filter($tmp)).'</span></span>';
	}

	public function getDetailEinrichtungAnschriftAsHTML()
	{

		if(empty(array_filter(array((string)$this->einrichtungStrasse, (string)$this->einrichtungPLZ, (string)$this->einrichtungOrt)))) return '';
		$tmp[]=array();
		if($this->einrichtungStrasse!='') $tmp['strasse']='<span property="streetAddress">'.$this->einrichtungStrasse.'</span>';
		if($this->einrichtungPLZ!='') $tmp['plz_ort']='<span itemprop="postalCode">'.$this->einrichtungPLZ.'</span>';
		if($this->einrichtungOrt!='') $tmp['plz_ort'].=' <span itemprop="addressLocality">'.$this->einrichtungOrt.'</span>';

		if(empty($tmp)) return '';

		return '<span itemprop="jobLocation" itemscope itemtype="http://schema.org/Place"><span itemprop="address" itemscope itemtype="http://schema.org/PostalAddress">'.implode("<br>\n", array_filter($tmp)).'</span></span>';
	}

	public function getDetailAgenturAnschriftAsHTML()
	{

		if(empty(array_filter(array((string)$this->agenturStrasse, (string)$this->agenturPLZ, (string)$this->agenturOrt)))) return '';
		$tmp[]=array();
		if($this->agenturStrasse!='') $tmp['strasse']='<span property="streetAddress">'.$this->agenturStrasse.'</span>';
		if($this->agenturPLZ!='') $tmp['plz_ort']='<span itemprop="postalCode">'.$this->agenturPLZ.'</span>';
		if($this->agenturOrt!='') $tmp['plz_ort'].=' <span itemprop="addressLocality">'.$this->agenturOrt.'</span>';

		if(empty($tmp)) return '';

		return '<span itemprop="jobLocation" itemscope itemtype="http://schema.org/Place"><span itemprop="address" itemscope itemtype="http://schema.org/PostalAddress">'.implode("<br>\n", array_filter($tmp)).'</span></span>';
	}

	public function getDetailPlzOrtAsHTML()
	{
		if(empty(array_filter(array((string)$this->angebotPLZ, (string)$this->angebotOrt)))) return '';

		$out='<span itemprop="jobLocation" itemscope itemtype="http://schema.org/Place"><span itemprop="address" itemscope itemtype="http://schema.org/PostalAddress">';
		if($this->angebotPLZ!='') $out.='<span itemprop="postalCode">'.$this->angebotPLZ.'</span> ';
		if($this->angebotOrt!='') $out.='<span itemprop="addressLocality">'.$this->angebotOrt.'</span>';
		$out.='</span></span>';

		return $out;
	}

	/**
	 * Zum "entwickeln/anpassen" koennen hiermit alle Parameter tabellarisch ausgegeben werden.
	 * @return string
	 */
	public function getDetailAlleParameterAsHTML()
	{
		return '<br>FreinetPortalAngebotDetail::__construct:'.freinet_portal_print_a(freinet_portal_object2array($this->AlleParamter), 1);
	}

	/**
	 * Erzeugt eine gekuerzte Version der Angebotsbeschreibung
	 * @ToDo Laenge der Kurzfassung im AdminArea einstellbar machen.
	 * @param int $maxLength
	 * @return string
	 */
	public function getDetailKurzBeschreibung($maxLength='300')
	{
		$this->beschreibung=strip_tags($this->beschreibung);
		if(strlen($this->beschreibung)>=$maxLength)
		{
			$shortendText=substr($this->beschreibung, 0, $maxLength);
			$fixed=$this->closeTags($shortendText);
			return $fixed."...";
		}
		return $this->beschreibung;
	}

	public function getDetailAngebotsPLZ()
	{
		return $this->angebotPLZ;
	}

	public function getDetailAngebotsOrt()
	{
		return $this->angebotOrt;
	}

	/**
	 * Erzeugt den Avatar
	 * @return string
	 */
	public function getDetailAngebotsAvatarAsHTML()
	{
		/*
		 * @ToDo Die Groesse des Avatars sollte im Adminarea waehlbar sein.
		 * Die Avatare liegen unter der URL //freinet-online.de/content/files/ds_avatar/ in verschiedenen Groessen vor
		 * avatar_h20px.jpg|.png
		 * avatar_w100px.jpg|.png
		 * avatar_w150px.jpg|.png
		 * avatar_w250px.jpg|.png
		 * avatar.jpg|.png // Achtung - Original (Groesse beachten!)
		 */
		if($this->angebotAvatar!='')
		{
			$this->angebotAvatar=str_replace('.', '_w150px.', $this->angebotAvatar);
			return FreinetPortalImageTagRenderer::fromUrl('//freinet-online.de/content/files/ds_avatar/'.$this->angebotAvatar.'');
		}
		elseif(get_option('freinet_portal_show_avatar_dummy')!='')
		{
			return FreinetPortalImageTagRenderer::fromUrl(get_option('freinet_portal_show_avatar_dummy'));
		}
		else
		{
			return '';
		}
	}

	/**
	 * anzeigeLink() in AngebotDetail
	 * @param FreinetPortalSearchParams $suchParameter
	 * @return string
	 */
	public function anzeigeLink(FreinetPortalSearchParams $suchParameter)
	{
		$freinetSearchQueryArgs['freinet_portal_wp_action']='angebot_anzeigen';
		$freinetSearchQueryArgs['freinet_portal_wp_angebot_nummer']=$this->getAngebotsId();
        $umkreis=implode(',', $suchParameter->getUmkreis());
		if($umkreis>0) $freinetSearchQueryArgs['freinetSearchData[umkreis]']=$umkreis;
        foreach (FreinetPortalKriterium::CRITERIAS as $criteriaName)
		{
			// 2021-09-09 only, if value not empty
			if($suchParameter->getCriterias()[$criteriaName]!='') $freinetSearchQueryArgs[$criteriaName] = $suchParameter->getCriterias()[$criteriaName];
		}

		// @Todo schau mal, Andre, spricht an dieser Stelle etwas gegen array_filter() ?
		return add_query_arg($freinetSearchQueryArgs);
	}

	/**
	 * Gibt eine Leaflet-Map mit den AngebotGeoDaten zurueck
	 * @return string
	 */
	public function getDetailAngebotMapAsHTML()
	{
		if($this->angebotGeoWidth=='' && $this->angebotGeoLength=='') return '';

		return freinet_portal_draw_leaflet_map($mapID='AngebotMap', $this->angebotGeoWidth, $this->angebotGeoLength);
	}

	/**
	 * Gibt eine Leaflet-Map mit den AngebotGeoDaten zurueck
	 * @return string
	 */
	public function getDetailEinrichtungMapAsHTML()
	{
		if($this->einrichtungGeoWidth=='' && $this->einrichtungGeoLength=='') return '';

		return freinet_portal_draw_leaflet_map($mapID='EinrichtungMap', $this->einrichtungGeoWidth, $this->einrichtungGeoLength);
	}

	/**
	 * Gibt eine Leaflet-Map mit den AngebotGeoDaten zurueck
	 * @return string
	 */
	public function getDetailAgenturMapAsHTML()
	{
		if($this->agenturGeoWidth=='' && $this->agenturGeoLength=='') return '';

		return freinet_portal_draw_leaflet_map($mapID='AgenturMap', $this->agenturGeoWidth, $this->agenturGeoLength);
	}

	public function getDetailEinrichtungID()
	{
		return $this->einrichtungId;
	}

	public function getDetailAgenturID()
	{
		return $this->agenturId;
	}

	private function closeTags($html)
	{
		// Credit goes to https://gist.github.com/JayWood/348752b568ecd63ae5ce
		preg_match_all('#<([a-z]+)(?: .*)?(?<![/|/ ])>#iU', $html, $result);
		$openedtags=$result[1];
		preg_match_all('#</([a-z]+)>#iU', $html, $result);
		$closedtags=$result[1];
		$len_opened=count($openedtags);
		if(count($closedtags)==$len_opened)
		{
			return $html;
		}
		$openedtags=array_reverse($openedtags);
		for($i=0; $i<$len_opened; $i++)
		{
			if(!in_array($openedtags[$i], $closedtags))
			{
				$html.='</'.$openedtags[$i].'>';
			}
			else
			{
				unset($closedtags[array_search($openedtags[$i], $closedtags)]);
			}
		}
		$html=str_replace('</br>', '', $html); // 2018-08-28 this function also closes <br>...
		return $html;
	}

	public function getDetailWertigkeit()
	{
		return $this->wertigkeit;
	}

	public function setWertigkeit($wertigkeit)
	{
		$this->wertigkeit=$wertigkeit;
	}

}