<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;

class FreinetPortalSearchResultPage extends FreinetPortalePublicAbstractPage
{
	function render($suchkonfigurationId)
	{
		$searchParams=FreinetPortalSearchParams::fromRequest($_REQUEST['freinetSearchData'], $suchkonfigurationId);
		$anzuzeigende_projekte=get_option(FreinetPortalSettings::anzuzeigende_projekt_liste($suchkonfigurationId));
		if ($anzuzeigende_projekte)
        {
            $searchParams->setProjektListe($anzuzeigende_projekte);
        }
		$projekt_ausschluss_liste=sprintf(get_option('freinet_portal_%d_projekt_ausschluss_liste', $suchkonfigurationId));
		if ($projekt_ausschluss_liste)
		{
		    $searchParams->setProjektAusschlussListe($projekt_ausschluss_liste);
        }
		/** @noinspection PhpUnusedLocalVariableInspection wird in ergebnis.php in der View benutzt */
		$freinetAngebote=$this->apiClient->search($searchParams, $suchkonfigurationId);
		if($this->showSearchForm($suchkonfigurationId))
		{
			$searchPage=new FreinetPortalSearchPage($this->apiClient);
			$searchPage->render($suchkonfigurationId);
		}
		$freinetFormPagingRenderer=new FreinetPortalFormPagingRenderer(
			$freinetAngebote->getGesamtAnzahlErgebnisse(),
			esc_attr(get_option(FreinetPortalSettings::freinet_suchergebnis_seitenweise_anzahl($suchkonfigurationId))),
			$searchParams->getPage(),
			esc_attr(get_option(FreinetPortalSettings::suchergebnis_seitenweise_anzeigen($suchkonfigurationId)))
		);
		$formElements['pagingButtonRow']=$freinetFormPagingRenderer->render();

		if(is_file(plugin_dir_path(__FILE__).'suche/ergebnis_CUSTOM.php'))
		{
			require_once(plugin_dir_path(__FILE__).'suche/ergebnis_CUSTOM.php');
		}
		else
		{
			require_once(plugin_dir_path(__FILE__).'suche/ergebnis.php');
		}
	}

	private function showSearchForm($suchkonfigurationId)
	{
		return get_option(FreinetPortalSettings::suchformular_in_ergebnisliste_anzeigen($suchkonfigurationId));
	}
}

class FreinetPortalOfferDetailPage extends FreinetPortalePublicAbstractPage
{
	function render($suchkonfigurationId)
	{
		$angebotsId=$_REQUEST['freinet_portal_wp_angebot_nummer'];
		if($this->showSearchForm($suchkonfigurationId))
		{
			$searchPage=new FreinetPortalSearchPage($this->apiClient);
			$searchPage->render($suchkonfigurationId);
		}
		/** @noinspection PhpUnusedLocalVariableInspection wird in angebot.php in der View benutzt */
		$freinetAngebot=$this->apiClient->loadOffer($angebotsId);

		if(is_file(plugin_dir_path(__FILE__).'suche/angebot_CUSTOM.php'))
		{
			require_once(plugin_dir_path(__FILE__).'suche/angebot_CUSTOM.php');
		}
		else
		{
			require_once(plugin_dir_path(__FILE__).'suche/angebot.php');
		}
	}

	private function showSearchForm($suchkonfigurationId)
	{
		return get_option(FreinetPortalSettings::suchformular_in_angebotsansicht_anzeigen($suchkonfigurationId));
	}
}

class FreinetPortalSearchPage extends FreinetPortalePublicAbstractPage
{
	function render($suchkonfigurationId)
	{
		/** @noinspection PhpUnusedLocalVariableInspection wird in form.php in der View benutzt */
		$criteria=$this->apiClient->getCriteriasAsArray($suchkonfigurationId);
		/** @noinspection PhpUnusedLocalVariableInspection wird in form.php in der View benutzt */
		$freinetSearchData=$_REQUEST['freinetSearchData'];
		/** @noinspection PhpUnusedLocalVariableInspection wird in form.php in der View benutzt */
		$formElements['angebotplzs']=$this->plzSelectBox($criteria, $freinetSearchData, $suchkonfigurationId);
		/** @noinspection PhpUnusedLocalVariableInspection wird in form.php in der View benutzt */
		$formElements['umkreis']=$this->umkreisSelectBox($criteria, $freinetSearchData);
		$formElements['suchbegriff']=$this->renderSuchBegriff($freinetSearchData['suchbegriff']);
		$formElements['verknuepfen']=$this->renderVerknuepfen($freinetSearchData['verknuepfen']);
		foreach($this->wpOptions($suchkonfigurationId) as $matching_kategorie=>$wp_matching_kategorie)
		{
			if(!empty($criteria)) $formElements[$matching_kategorie]=$this->renderCriteriaForm($criteria, $freinetSearchData, $matching_kategorie, $suchkonfigurationId);
		}

		if(is_file(plugin_dir_path(__FILE__).'suche/form_CUSTOM.php'))
		{
			require_once(plugin_dir_path(__FILE__).'suche/form_CUSTOM.php');
		}
		else
		{
			require_once(plugin_dir_path(__FILE__).'suche/form.php');
		}
	}

    private function wpOptions($suchkonfiugrationId)
    {
        $prefix=$this->criteriaPrefix($suchkonfiugrationId);
        return array(
            'arbeitsweisen'=>$prefix . 'arbeitsweisen',
            'zielgruppen'=>$prefix . 'zielgruppen',
            'ziel2gruppen'=>$prefix . 'ziel2gruppen',
            'handlungsfelder'=>$prefix . 'handlungsfelder',
            'handlungs2felder'=>$prefix . 'handlungs2felder',
            'kenntnisse'=>$prefix . 'kenntnisse',
            'globalbereiche'=>$prefix . 'globalbereiche',
            'sprachen'=>$prefix . 'sprachen',
            'stadtteile'=>$prefix . 'stadtteile',
            'umgebung'=>$prefix . 'umgebung',
            'zeitspenden'=>$prefix . 'zeitspenden',
            'sachspenden'=>$prefix . 'sachspenden',
			'mtffa1'=>$prefix . 'mtffa1',
			'mtffa2'=>$prefix . 'mtffa2',
			'mtffa3'=>$prefix . 'mtffa3',
			'mtffa4'=>$prefix . 'mtffa4',
			'mtffa5'=>$prefix . 'mtffa5',
			'mtffa6'=>$prefix . 'mtffa6',
			'ehrenamttyp' =>$prefix . 'ehrenamttyp',
			'portalmatrix1' =>$prefix . 'portalmatrix1',
			'portalmatrix2' =>$prefix . 'portalmatrix2'
        );
    }

    private function criteriaPrefix($suchkonfiugrationId)
    {
        return sprintf('freinet_portal_%s_matchingcriteria_use_', $suchkonfiugrationId);
    }

	/**
	 * Erzeugt das DropDownfeld "PLZ"
	 *
	 * @param $criteria
	 * @param $freinetSearchData
	 * @return FreinetPortalFormSelectBoxRenderer
	 */
	private function plzSelectBox($criteria, $freinetSearchData, $suchkonfigurationId)
	{

		$choice=get_option($this->criteriaPrefix($suchkonfigurationId) . 'angebotplzs');

		if($choice==3)
		{
			return new FreinetPortalFormInputTextRenderer(
				$criteria['angebotplzs'],
				'freinetSearchData[angebotplzs]',
				'adress_plz_ort',
				trim($freinetSearchData['angebotplzs']),
				array('placeholder'=>'PLZ')
			);
		}

		return new FreinetPortalFormSelectBoxRenderer(
			$criteria['angebotplzs'],
			'freinetSearchData[angebotplzs]',
			'adress_plz_ort',
			$freinetSearchData['angebotplzs']
		);
	}

	/**
	 * Erzeugt das DropDownfeld "Umkreis"
	 *
	 * @param $criteria
	 * @param $freinetSearchData
	 * @return FreinetPortalFormSelectBoxRenderer
	 */
	private function umkreisSelectBox($criteria, $freinetSearchData)
	{
		return new FreinetPortalFormSelectBoxRenderer(
			$criteria['umkreis'],
			'freinetSearchData[umkreis]',
			'umkreis',
			$freinetSearchData['umkreis']
		);
	}

	/**
	 * Hier wird ausgewählt, welches Filterformular gerendert werden soll.
	 * @param $criteria
	 * @param $freinetSearchData
	 * @param $criteriaName
	 * @param $suchkonfigurationId
	 *
	 * @return FreinetPortalFormCheckBoxRenderer|FreinetPortalFormCheckButtonRenderer|FreinetPortalFormSelectBoxRenderer|FreinetPortalFormSelectCheckBoxesRenderer|FreinetPortalPortalFormInputTextRenderer
	 */
	private function renderCriteriaForm($criteria, $freinetSearchData, $criteriaName, $suchkonfigurationId)
	{
	    $prefix=sprintf('freinet_portal_%d_matchingcriteria_use_', $suchkonfigurationId);
		$choice=get_option($prefix.$criteriaName);

		// CheckButton
		if($choice==5)
		{
			wp_enqueue_style( 'dashicons' ); // Wir benötigen die Wordpress DashIcons siehe https://developer.wordpress.org/resource/dashicons/#arrow-up-alt2

			return new FreinetPortalFormCheckButtonRenderer(
				$criteria[$criteriaName],
				'freinetSearchData['.$criteriaName.']',
				$criteriaName,
				$freinetSearchData[$criteriaName]
			);
		}
		// SelectCheckBoxes
		elseif($choice==4)
		{
			wp_enqueue_style( 'dashicons' ); // Wir benötigen die Wordpress DashIcons siehe https://developer.wordpress.org/resource/dashicons/#arrow-up-alt2

			return new FreinetPortalFormSelectCheckBoxesRenderer(
				$criteria[$criteriaName],
				'freinetSearchData['.$criteriaName.']',
				$criteriaName,
				$freinetSearchData[$criteriaName]
			);
		}
		// Text Input
		elseif($choice==3)
		{
			return new FreinetPortalFormInputTextRenderer(
				$criteria[$criteriaName],
				'freinetSearchData['.$criteriaName.']',
				$criteriaName,
				$freinetSearchData[$criteriaName]
			);
		}
		elseif($choice==2)
		{
			return new FreinetFormCheckBoxRenderer(
				$criteria[$criteriaName],
				'freinetSearchData['.$criteriaName.']',
				$criteriaName,
				$freinetSearchData[$criteriaName]
			);
		}
		return new FreinetPortalFormSelectBoxRenderer(
			$criteria[$criteriaName],
			'freinetSearchData['.$criteriaName.']',
			$criteriaName,
			$freinetSearchData[$criteriaName]
		);
	}

	private function renderSuchBegriff($suchbegriff)
	{
		if($suchbegriff)
		{
			return '<input id="suchbegriff" type="text" name="freinetSearchData[suchbegriff]" value="'.strip_tags($suchbegriff).'">';
		}
		return '<input id="suchbegriff" type="text" name="freinetSearchData[suchbegriff]">';
	}

	private function renderVerknuepfen($verknuepfen)
	{
		if($verknuepfen)
		{
			return '<input type="checkbox" id="verknuepfen" name="freinetSearchData[verknuepfen]" value="verknuepfen" checked>';
		}
		return '<input type="checkbox" id="verknuepfen" name="freinetSearchData[verknuepfen]" value="verknuepfen">';
	}
}

abstract class FreinetPortalePublicAbstractPage
{
	protected $apiClient;

	public function __construct(FreinetPortalApiClient $apiClient)
	{
		$this->apiClient=$apiClient;
	}

	abstract public function render($suchkonfigurationId);
}

function freinet_portal_debug($message, $reference, $line, $file)
{
    $message = str_replace(get_option('freinet_portal_api_key'), "***", $message);
	if(FREINET_PORTAL_WP_DEBUG)
	{
		echo '<br>'.$file.':'.$line.' '.$reference.': <hr>'.$message;
	}
}

function freinet_portal_xml_attribute($object, $attribute)
{
	if(isset($object[$attribute]))
	{
		return (string)$object[$attribute];
	}
}

/**
 * Diese Funktion erstellt aus einem Objekt ein Array
 *
 * @tags object_to_array, obj_to_arr
 * @param $obj
 * @return array
 */
function freinet_portal_object2array($obj)
{
	$_arr=is_object($obj) ? get_object_vars($obj) : $obj;
	$arr=array();
	if(!empty($_arr))
	{
		foreach($_arr as $key=>$val)
		{
			$val=(is_array($val) || is_object($val)) ? freinet_portal_object2array($val) : $val;
			$arr[$key]=$val;
		}
	}
	return $arr;
}


/**
 * Erstellt aus einem Array eine list
 *
 * @Tags array_to_list arr2list arr_to_ul
 * @param $array
 * @param string $ul_ol mixed ol | ul
 * @param int $do_htmlspecialchars bit sollen die Elemente htmlspecialchars werden?
 * @param string $ul_class
 * @param string $li_class
 * @return string
 */
function freinet_portal_array2ul($array, $ul_ol='ol', $do_htmlspecialchars=1, $ul_class='', $li_class='', $options=array())
{
	$class_ul='';
	if($ul_class!='') $class_ul=' class="'.$ul_class.'"';
	$class_li='';
	if($li_class!='') $class_li=' class="'.$li_class.'"';

	$and_style='';
	if(isset($options['style'])) $and_style=' style="'.$options['style'].'"';

	$out='<'.$ul_ol.$class_ul.$and_style.'>';


	if(!empty($array))
	{
		foreach($array as $key=>$elem)
		{
			if(!is_array($elem))
			{
				if($do_htmlspecialchars==1)
				{
					$elem=htmlspecialchars($elem);
				}
				$out=$out."<li".$class_li."><span>$elem</span></li>";
			}
			else
			{
				$out=$out."<li".$class_li.">".freinet_portal_array2ul($elem, $ul_ol, $do_htmlspecialchars)."</li>"; // <span>$key</span>
			}
		}
	}

	$out=$out.'</'.$ul_ol.'>';

	return $out;
}

/**
 * Macht freinet_portal_print_a etwas huebscher...
 *
 * @param $TheArray
 * @param int $echo
 * @param int $html_specialchars
 * @param int $skip_numeric_keys
 * @param array $options =array()
 * @return string
 */
function freinet_portal_print_a($TheArray, $echo=0, $html_specialchars=0, $skip_numeric_keys=0, $options=array())
{ // Note: the function is recursive
	global $filename;

	$out='';

	if(!isset($options['tableclass'])) $options['tableclass']='innertblborder';

	if(is_array($TheArray))
	{
		$out.="<table class=\"".$options['tableclass']."\" border=\"0\" cellspacing=\"1\">\n";
		$Keys=array_keys($TheArray);
		//$Keys =$TheArray ;

		foreach($Keys as $OneKey)
		{
			if($skip_numeric_keys==1 && is_numeric($OneKey)) continue;

			$out.="<tr valign=\"top\" class=\"secondrow\">\n";
			$out.="<td>";
			//$out.="<B>".wordwrap($OneKey, 75, "<br />", true)."</B>";
			$out.="<B>".preg_replace("/([^\s]{150})/", "$1 ", $OneKey)."</B>";
			$out.="</td>\n";
			$out.="<td>";
			if(is_array($TheArray[$OneKey]))
			{
				$out.=freinet_portal_print_a($TheArray[$OneKey], 1, $html_specialchars, $skip_numeric_keys, $options);
			}
			elseif($html_specialchars==0)
			{
				//$out.=wordwrap(htmlspecialchars($TheArray[$OneKey]), 75, "<br />", true);
				$out.=preg_replace("/([^\s]{150})/", "$1 ", htmlspecialchars($TheArray[$OneKey]));
			}
			else
			{
				//$out.=wordwrap($TheArray[$OneKey], 75, "<br />", true);
				//$out.=preg_replace("/([^\s]{150})/", "$1 ", $TheArray[$OneKey]);
				$out.=$TheArray[$OneKey];
			}
			$out.="</td>\n";
			$out.="</tr>\n";
		}
		$out.="</table>\n";
	}
	elseif(is_string($TheArray)) $out.="<font color=\"blue\"><strong>function freinet_portal_print_a</strong> String gegeben: (".htmlspecialchars($TheArray).")</font>";
	else $out.="<font color=\"red\"><strong>function freinet_portal_print_a</strong> kein Array</font>";

	if($echo=="1")
	{
		return $out;
	}
	else
	{
		echo $out;
	}
}

/**
 * @param $template_name
 * @param $titel
 * @param $content
 * @param string $id
 * @param string $class
 * @param int $hide_if_empty
 * @return string
 */
function freinet_portal_Template($template_name, $titel, $content, $id='', $class='', $hide_if_empty=0)
{
	// Wenn der Content leer ist, wollen wir das Template nicht anzeigen
	if($hide_if_empty==1 && trim($content)=='') return '';

	$and_id='';
	if($id!='') $and_id=' id="'.$id.'"';
	$and_class='';
	if($class!='') $and_class=' '.$class;

	switch($template_name)
	{

		# ----------------------------------------------------------------------
		# Angebot DetailSeite Zweispaltig
		# ----------------------------------------------------------------------
		case'DetailZweiSpaltig':
			{
				$template="\n".'<div title="Anschrift"'.$and_id.' class="ym-grid linearize-level-480'.$and_class.'">
            <div class="ym-g33 ym-gl">
                <div class="ym-gbox block_title">'.$titel.'</div>
            </div>
            <div class="ym-g66 ym-gr">
                <div class="ym-gbox block_content">
					'.$content.'
                </div>
            </div>
        </div><!-- // yamlgrid -->';
				echo $template;
				break;
			}
		# ----------------------------------------------------------------------
		# Angebot DetailSeite Zweizeilig
		# ----------------------------------------------------------------------
		case'DetailZweilZeilig':
			{
				$template="\n".'<div title="Anschrift"'.$and_id.' class="ym-grid linearize-level-480'.$and_class.'">
            <div>
                <div class="ym-gbox block_title">'.$titel.'</div>
            </div>
            <div>
                <div class="ym-gbox block_content">
					'.$content.'
                </div>
            </div>
        </div><!-- // yamlgrid -->';
				echo $template;
				break;
			}
		# ----------------------------------------------------------------------
		# default: Normale Auflistung der Unterordner
		# ----------------------------------------------------------------------
		default:
			{
				echo 'TemplateName not exist in function freinet_portal_Template()';
				break;
			}
	}

}

/**
 * @param $width
 * @param $length
 * @return string
 */
function freinet_portal_draw_leaflet_map($mapID, $width, $length)
{
	global $js_css_done;

	if($width=='' && $length=='') return '';

	$output='';
	if(!isset($js_css_done))
	{
		$output="\n".'<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/leaflet/1.3.3/leaflet.css"/>';
		$output.="\n".'<script src="//cdnjs.cloudflare.com/ajax/libs/leaflet/1.3.3/leaflet.js"></script>';
	}
	$js_css_done=1;
	$output.="\n".'<div id="'.$mapID.'" style="width: 100%; height: 250px;"></div>';
	$output.="\n".'<script type="text/javascript">
	/* markerIcon */
	var MIcon = L.icon({
		iconUrl: \'//cdnjs.cloudflare.com/ajax/libs/leaflet/1.3.3/images/marker-icon-2x.png\',
		iconSize:     [25, 41], // size of the icon
		iconAnchor:   [0, 25]
	});
	/* map */
	var mymap = L.map(\''.$mapID.'\').setView(['.$width.', '.$length.'], 15);
	L.tileLayer(\'https://{s}.tile.openstreetmap.de/tiles/osmde/{z}/{x}/{y}.png\', {
		maxZoom: 20,
		attribution: \'&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>\'
	}).addTo(mymap);
	/* marker */
	L.marker(['.$width.', '.$length.'], {icon: MIcon}).addTo(mymap);
</script>';
	return $output;
}