<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;

class FreinetPortalFormCheckBoxRenderer extends FreinetPortalAbstractFormRenderer
{
    private $values;
    private $formName;
    private $classId;

    /**
     * @param array $values die Werteliste
     * @param string $formName Wie das name Attribut des select Elements benannt werden soll
     * @param string $classId die CSS Klasse für das <select> Element
     * @param mixed $preSelection der Wert der in der SelectBox vorselektiert sein soll
     */
    public function __construct(array $values, $formName, $classId, $preSelection)
    {
        $this->values = $values;
        $this->formName = $formName;
        $this->classId = $classId;
        $this->preSelection = $preSelection;
    }

    /**
     * Diese Funktion gibt das DropDown-Feld, bzw die Checkboxen zurück
     * Optional könnten natürlich auch zwei Funktionen her: Eine für DropDown und eine für Checkbpox
     * @param mixed $renderType DROPDOWN|CHECKBOX
     * @return string
     */
    public function render()
    {
        $selectBox = '<div name="' . $this->formName . '" id="' . $this->classId . '">';
        $i=0;
        foreach ($this->values as $key => $value)
        {
        	$i++;
            $sel = '';
            // Wenn ein Array an Werten selektiert wurde
            if (is_array($this->preSelection) && in_array($key, $this->preSelection))
            {
                $sel = ' checked';
            }
            // Wenn kein Array, sondern nur ein Wert selektiert ist.
            elseif (!is_array($this->preSelection) && $key == $this->preSelection)
            {
                $sel = ' checked';
            }
            $selectBox .= '<label class="option block"><input type="checkbox" name="' . $this->formName . '[]" value="' . $key . '"' . $sel . '> ' . $value . '</label>';

        }
        if($i==0) $selectBox .= '<label class="option block"><span style="visibility: hidden !important;"><input type="checkbox"></span> Keine Kriterien vorhanden -</label>';
        $selectBox .= '</div>';
        return $selectBox;
    }

}