<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;

/**
 * Diese Klasse erzeugt das html für die CheckButton.
 * Das CSS dafür finden Sie unter https://freinet-online.de/content/css/wordpress_freinet_api_portale.css unter den Klassen .CheckButton ff
 * @since // 2021-09-08
 */
class FreinetPortalFormCheckButtonRenderer extends FreinetPortalAbstractFormRenderer
{
    private $values;
    private $formName;
    private $classId;

    /**
     * @param array $values die Werteliste
     * @param string $formName Wie das name Attribut des select Elements benannt werden soll
     * @param string $classId die CSS Klasse für das <select> Element
     * @param mixed $preSelection der Wert der in der SelectBox vorselektiert sein soll
     */
    public function __construct(array $values, $formName, $classId, $preSelection)
    {
        $this->values = $values;
        $this->formName = $formName;
        $this->classId = $classId;
        $this->preSelection = $preSelection;
    }

    /**
     * Diese Funktion gibt die CheckButton zurück
     * @param mixed $renderType DROPDOWN|CHECKBOX|CHECKBUTTON|SELECTCHECKBOXES
     * @return string
     */
    public function render()
    {
		$form_CheckButton='';
		$OptionArrayLinks=array();

        $i=0;
        foreach ($this->values as $key => $value)
        {
        	$i++;
            $sel = '';
            // Wenn ein Array an Werten selektiert wurde
            if (is_array($this->preSelection) && in_array($key, $this->preSelection))
            {
                $sel = ' checked';
            }
            // Wenn kein Array, sondern nur ein Wert selektiert ist.
            elseif (!is_array($this->preSelection) && $key == $this->preSelection)
            {
                $sel = ' checked';
            }
			$OptionArrayLinks[]='<input id="fnCB_'.$key.'_'.$i.'" type="checkbox" name="' . $this->formName . '[]" value="' . $key . '"'.$sel.'><label for="fnCB_'.$key.'_'.$i.'"><span>'.$value.'</span></label>'."\n";
        }

		$form_CheckButton=implode("\n", $OptionArrayLinks);
		$selectBox='<div class="CheckButtonContainer '.$value.'"><!-- CheckButton Container -->'."\n".$form_CheckButton.'</div><!-- CheckButton Container Ende -->'."\n";
		if($i==0) $selectBox='<label class="option block"><span style="visibility: hidden !important;"><input type="checkbox"></span> Keine Kriterien vorhanden -</label>';

        return $selectBox;
    }

}