<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;

/**
 * @since // 2021-09-08
 */
class FreinetPortalFormInputTextRenderer extends FreinetPortalAbstractFormRenderer
{
    private $values;
    private $formName;
    private $classId;

    /**
     * @param array $values die Werteliste
     * @param string $formName Wie das name Attribut des select Elements benannt werden soll
     * @param string $classId die CSS Klasse für das <select> Element
     * @param mixed $preSelection der Wert der in der SelectBox vorselektiert sein soll
     * @param array $options z.B. "placeholder"
     */
    public function __construct(array $values, $formName, $classId, $preSelection, $options=array())
    {
        $this->values = $values;
        $this->formName = $formName;
        $this->classId = $classId;
        $this->preSelection = $preSelection;
        $this->options = $options;
    }

    /**
     * Diese Funktion gibt das DropDown-Feld, bzw die Checkboxen zurück
     * Optional könnten natürlich auch zwei Funktionen her: Eine für DropDown und eine für Checkbpox
     * @param mixed $renderType DROPDOWN|CHECKBOX
     * @return string
     */
    public function render()
    {

        $selectBox = '<div name="' . $this->formName . '" id="' . $this->classId . '">';

        $tmp=array();
        foreach ($this->values as $key => $value)
        {
			$tmp[]='<option value="'.trim(htmlspecialchars($value)).'">';
        }

        $and_list='';
        $list='';
		if(!empty($tmp))
		{
			$and_list=' list="fn_plzs"';
			$list='<datalist id="fn_plzs">'.implode("\n", $tmp).'</datalist>';
		}

		$placeholder='';
		if($this->options['placeholder']!='') $placeholder=' placeholder=" ' . htmlspecialchars($this->options['placeholder']) . '"';

        $selectBox .= '<input'.$and_list.' type="text" name="' . $this->formName . '" value="'.$this->preSelection.'"' . $placeholder . '>';
        $selectBox .= $list;

        //if($i==0) $selectBox .= '<label class="option block"><span style="visibility: hidden !important;"><input type="checkbox"></span> Keine Kriterien vorhanden -</label>';
        $selectBox .= '</div>';
        return $selectBox;
    }

}