<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;

class FreinetPortalFormSelectBoxRenderer extends FreinetPortalAbstractFormRenderer
{
    private $values;
    private $formName;
    private $classId;
    private $showAll;

    /**
     * @param array $values die Werteliste (die Matchingkriterien)
     * @param string $formName Wie das name Attribut des select Elements benannt werden soll
     * @param string $classId die CSS Klasse für das <select> Element
     * @param mixed $preSelection der Wert der in der SelectBox vorselektiert sein soll
     */
    public function __construct(array $values, $formName, $classId, $preSelection)
    {
        $this->values = $values;
        $this->formName = $formName;
        $this->classId = $classId;
        $this->preSelection = $preSelection;
        $this->showAll = true;
    }

    /**
     * Diese Funktion gibt das DropDown-Feld, bzw die Checkboxen zurück
     * Optional könnten natürlich auch zwei Funktionen her: Eine für DropDown und eine für Checkbpox
     * @param mixed $renderType DROPDOWN|CHECKBOX
     * @return string
     */
    public function render()
    {
        $selectBox = '<select name="' . $this->formName . '" id="' . $this->classId . '">';
        if ($this->showAll)
        {
            $selectBox .= '<option value="">Alle anzeigen</option>';
        }
        foreach ($this->values as $key => $value)
        {
            if ($key == $this->preSelection)
            {
                $selectBox .= "<option value=\"$key\" selected>$value</option>";
            }
            else
            {
                $selectBox .= "<option value=\"$key\">$value</option>";
            }
        }
        $selectBox .= '</select>';
        return $selectBox;
    }

    public function disableShowAll()
    {
        $this->showAll = false;
    }

}