<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;

/**
 * Diese Klasse erzeugt das html für das "<select>" ähnliche Formular, bei dem bei Klick jedoch Checkboxen erscheinen
 * @since 2021-09-08
 */
class FreinetPortalFormSelectCheckBoxesRenderer extends FreinetPortalAbstractFormRenderer
{
    private $values;
    private $formName;
    private $classId;

    /**
     * @param array $values die Werteliste
     * @param string $formName Wie das name Attribut des select Elements benannt werden soll
     * @param string $classId die CSS Klasse für das <select> Element
     * @param mixed $preSelection der Wert der in der SelectBox vorselektiert sein soll
     */
    public function __construct(array $values, $formName, $classId, $preSelection)
    {
        $this->values = $values;
        $this->formName = $formName;
        $this->classId = $classId;
        $this->preSelection = $preSelection;
    }

    /**
     * Diese Funktion gibt das SelectCheckBoxes-Feld zurück
     * @param mixed $renderType DROPDOWN|CHECKBOX
     * @return string
     */
    public function render()
    {

		$array_checkbutton['l']=array();
		$array_checkbutton['r']=array();
		$count_selected=0;

        $selectBox = '<div name="' . $this->formName . '" id="' . $this->classId . '">';
        $i=0;
        foreach ($this->values as $key => $value)
        {
        	$i++;
            $sel = '';
            // Wenn ein Array an Werten selektiert wurde
            if (is_array($this->preSelection) && in_array($key, $this->preSelection))
            {
				$count_selected++;
                $sel = ' checked';
            }
            // Wenn kein Array, sondern nur ein Wert selektiert ist.
            elseif (!is_array($this->preSelection) && $key == $this->preSelection)
            {
				$count_selected++;
                $sel = ' checked';
            }

			$l_r = ( $i%2 == 0 ) ? 'r' : 'l';
			$array_checkbutton[$l_r][]='<label class="option block" for="fnSCB_'.$key.'_'.$i.'"><input type="checkbox" id="fnSCB_'.$key.'_'.$i.'" name="' . $this->formName . '[]" value="'.$key.'"'.$sel.'><span class="checkbox"></span> '.$value.'</label>'."\n";
		}


		if($formName!='')
		{
			$kat_titel=$formName;
		}
		else
			$kat_titel='Alle anzeigen';

		$l=implode('', $array_checkbutton['l']);
		$r=implode('', $array_checkbutton['r']);
		$span_count_selected='<span class="SelectCheckBoxesBubble"></span>';
		$style_hidden_field='display:none;';
		// $fa_icon='fas fa-angle-down'; // FontAwesome
		$fa_icon='dashicons dashicons-arrow-down-alt2';
		if($count_selected>0)
		{
			// $fa_icon='fas fa-angle-up'; // FontAwesome
			$fa_icon='dashicons dashicons-arrow-up-alt2';
			$style_hidden_field='';
			$span_count_selected='<span class="SelectCheckBoxesBubble"></span>'; // '.$count_selected.'
		}
		$out_SCB='<div id="SCB_'.$value.'" class="SelectCheckBoxes '.$value.'">
<button type="button" class="field select SelectCheckBoxesTitel"><i class="'.$fa_icon.'"></i> '.$span_count_selected.''.$kat_titel.'</button>
<div class="SelectCheckBoxesHidden" style="'.$style_hidden_field.'">';
		if(trim($l.$r)=='')
		{
			$out_SCB.='
<!-- yamlgrid -->
<div class="ym-grid linearize-level-800">
<div class="ym-g100 ym-gl">
  <div class="ym-gbox">Hoppla, keine Kriterien vorhanden</div>
</div>
</div><!-- // yamlgrid -->';
		}
		elseif($l!='' && $r!='')
		{
			$out_SCB.='
<!-- yamlgrid -->
<div class="ym-grid linearize-level-800">
<div class="ym-g50 ym-gl">
  <div class="ym-gbox">'.$l.'</div>
</div>
<div class="ym-g50 ym-gr">
  <div class="ym-gbox">'.$r.'</div>
</div>
</div><!-- // yamlgrid -->';
		}
		else
		{
			$out_SCB.='
<!-- yamlgrid -->
<div class="ym-grid linearize-level-800">
<div class="ym-g100 ym-gl">
  <div class="ym-gbox">'.$l.$r.'</div>
</div>
</div><!-- // yamlgrid -->';
		}

		if($count_selected>0) $out_SCB=str_replace('<span class="SelectCheckBoxesBubble"></span>', '<span class="SelectCheckBoxesBubble">'.$count_selected.'</span>', $out_SCB);
		$out_SCB.='</div></div>';


        if($i==0) $selectBox .= '<label class="option block"><span style="visibility: hidden !important;"><input type="checkbox"></span> Keine Kriterien vorhanden -</label>';
		$selectBox .= $out_SCB;

		// Nur wenn Inhalte vorhanden sind, soll das Javascript erzeugt werden
		if($i>0)
		{
			// Pfad zur js Datei für die SelectCheckBoxes
			wp_enqueue_script( 'script', plugins_url('freinet_api_portale/suche/js/FreinetSelectCheckBoxes.js'), array ( 'jquery' ), 1.1, true);
		}

		$selectBox .= '</div>';
        return $selectBox;
    }

}