<?php
// Sicherheitscheck, ob diese Datei im Wordpresscontext läuft. Ansonsten wird die Verarbeitung abgebrochen.
defined('ABSPATH') or die;

class FreinetPortalSearchParams
{
    private $criterias;
    private $umkreis;
    private $page;
    private $suchbegriff;
    private $suchmodus;
    private $projekt_ausschluss_liste;
    private $projekt_liste;

    public function __construct(array $criterias, array $umkreis, $suchbegriff)
    {
        $this->criterias = $criterias;
        $this->umkreis = $umkreis;
        $this->suchbegriff = $suchbegriff;
    }

    public function getCriterias()
    {
        return $this->criterias;
    }

    public function getUmkreis()
    {
        return $this->umkreis;
    }

    public function getPage()
    {
        return $this->page;
    }

    public function setPage($page)
    {
        $this->page = $page;
    }

    public function getSuchbegriff()
    {
        return $this->suchbegriff;
    }

    public function getSuchmodus()
    {
        return $this->suchmodus;
    }

    public function setSuchmodus($suchmodus)
    {
        $this->suchmodus = $suchmodus;
    }

    /**
     * @param string $projekt_ausschluss_liste als kommasepariete Liste
     */
    public function setProjektAusschlussListe($projekt_ausschluss_liste)
    {
        $this->projekt_ausschluss_liste = $projekt_ausschluss_liste;
    }

    /**
     * @return string Projekt-IDs die ausgeschlossen werden sollen als kommaseparierte Liste
     */
    public function getProjektAusschlussListe()
    {
        return $this->projekt_ausschluss_liste;
    }

    /**
     * @return string
     */
    public function getProjektListe()
    {
        return $this->projekt_liste;
    }

    /**
     * @param string $projekt_liste
     */
    public function setProjektListe($projekt_liste)
    {
        $this->projekt_liste = $projekt_liste;
    }

    public static function fromRequest($request, $suchkonfigurationId)
    {
        $criterias = array();
        foreach (FreinetPortalKriterium::CRITERIAS as $criteria)
        {
            $criterias[$criteria] = self::prepareApiSearchParam($request[$criteria]);
        }
        $freinetSearchParams = new FreinetPortalSearchParams($criterias, self::prepareApiSearchParam($request['umkreis']), $request['suchbegriff']);
        if ($request[FREINET_PORTAL_URL_PARAMS['ergebnis_page']])
        {
            $freinetSearchParams->setPage($request[FREINET_PORTAL_URL_PARAMS['ergebnis_page']]);
        }
        if ($request['verknuepfen'] == 'verknuepfen')
        {
            $freinetSearchParams->setSuchmodus("und");
        }
        return $freinetSearchParams;
    }

    public static function prepareApiSearchParam($value)
    {
        if (is_array($value))
        {
            return $value;
        }
        return array($value);
    }
}