<?php

class FreinetPortalSearchResult
{
    private $angebote;
    private $anzahlErgebnisse;
    private $gesamtAnzahlErgebnisse;

    public function __construct()
    {
        $this->angebote=array();
    }

    public function getAngebote()
    {
        return $this->angebote;
    }

    public function addAngebot(FreinetPortalAngebotListe $angebot)
    {
        array_push($this->angebote, $angebot);
    }

    /*
     * Bildet das Objekt der Angebote fuer die Ergebnisliste
	 * @lastmodified // 2020-10-24 added agenturid, agenturname, termine, anzahl_gesuche, anzahl_aktueller_vermittlungen
     */
    public static function fromXmlString($data)
    {
        $angebotsListe=new SimpleXMLElement($data);
        $freinetSearchResult=new FreinetPortalSearchResult();
        $freinetSearchResult->setGesamtAnzahlErgebnisse($angebotsListe['GesamtAnzahlErgebnisse'][0]);
        $freinetSearchResult->setAnzahlErgebnisse($angebotsListe['anzahlErgebnisse'][0]);

        foreach($angebotsListe as $angebotXmlData)
        {

            //echo 'FreinetPortalClasses.php:'.__LINE__.':'.freinet_portal_print_a(freinet_portal_object2array($angebotXmlData),1); // unkommentieren um alle Bestandteile des Objekts zu sehen

            $angebot=new FreinetPortalAngebotListe(
                (string)$angebotXmlData['angebotsId'][0],
                $angebotXmlData->angebotsname,
                $angebotXmlData->agenturid,
                $angebotXmlData->agenturname,
                $angebotXmlData->einrichtungsname,
                $angebotXmlData->beschreibung,
                $angebotXmlData->plz,
                $angebotXmlData->ort,
                $angebotXmlData->avatar,
                $angebotXmlData->termine,
                $angebotXmlData->anzahl_gesuche,
                $angebotXmlData->anzahl_aktueller_vermittlungen,
                $angebotXmlData->kontaktierbar
            );
            $angebot->setWertigkeit($angebotXmlData->wertigkeit[0]);
            $freinetSearchResult->addAngebot($angebot);
        }

        return $freinetSearchResult;
    }

    public function setAnzahlErgebnisse($anzahlErgebnisse)
    {
        $this->anzahlErgebnisse=$anzahlErgebnisse;
    }

    public function getAnzahlErgebnisse()
    {
        return $this->anzahlErgebnisse;
    }

    public function getGesamtAnzahlErgebnisse()
    {
        return $this->gesamtAnzahlErgebnisse;
    }

    public function setGesamtAnzahlErgebnisse($gesamtAnzahlErgebnisse)
    {
        $this->gesamtAnzahlErgebnisse=$gesamtAnzahlErgebnisse;
    }
}